﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2021.2.2),
    on November 16, 2021, at 10:03
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from __future__ import absolute_import, division

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard

import bbtk_psurp
from psychopy.iohub import launchHubServer
from psychopy.core import getTime
from psychopy import core

import sys
import array as arr
from datetime import datetime

print("BEFORE EXPERIMENT")
datRTC = datetime.now().strftime('%Y/%m/%d %H:%M:%S.%f')[:-3]
print(datRTC)


# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)

# Store info about the experiment session
psychopyVersion = '2021.2.2'
expName = 'Simple BBTK PSURP Experiment'  # from the Builder filename that created this script
expInfo = {'participant': '', 'session': '001'}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\BBTK PSURP\\PsychoPy v2021.2.2 Example\\BBTK PSURP Example Experiment_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.DEBUG)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[2560, 1440], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[-1,-1,-1], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# Setup eyetracking
ioDevice = ioConfig = ioSession = ioServer = eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard()

# Initialize components for Routine "instructions"
instructionsClock = core.Clock()
instructText = visual.TextStim(win=win, name='instructText',
    text='WELCOME A SIMPLE\nBBTK PSURP\nTEST EXPERIMENT\n\nPress button 1 if green\nPress button 2 if red\n[ESC] will quit\n\nI will debrief you after the experiment.\n\nREMEMBER to start the PSURP App logging before you start the experiment. You will be presented with 10 trials in total.\n\nPress [SPACE] to start',
    font='Open Sans',
    pos=(0, 0), height=0.04, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
ready = keyboard.Keyboard()
startSquare = visual.Rect(
    win=win, name='startSquare',units='norm', 
    width=(0.4, 0.2)[0], height=(0.4, 0.2)[1],
    ori=0.0, pos=(0.9, 0),
    lineWidth=1.0,     colorSpace='rgb',  lineColor='black', fillColor='black',
    opacity=None, depth=-2.0, interpolate=True)

# Initialize components for Routine "black_marker"
black_markerClock = core.Clock()
blackSquare = visual.Rect(
    win=win, name='blackSquare',units='norm', 
    width=(0.4, 0.2)[0], height=(0.4, 0.2)[1],
    ori=0.0, pos=(0.9, 0),
    lineWidth=1.0,     colorSpace='rgb',  lineColor='black', fillColor='black',
    opacity=None, depth=0.0, interpolate=True)

# Initialize components for Routine "white_marker"
white_markerClock = core.Clock()
whiteSquare = visual.Rect(
    win=win, name='whiteSquare',units='norm', 
    width=(0.4, 0.2)[0], height=(0.4, 0.2)[1],
    ori=0.0, pos=(0.9, 0),
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=None, depth=0.0, interpolate=True)
image = visual.ImageStim(
    win=win,
    name='image', 
    image='sin', mask=None,
    ori=0.0, pos=(0, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-1.0)
# Start the ioHub process. 'io' can now be used during the
# experiment to access iohub devices and read iohub device events.
io = launchHubServer()
keyboard = io.devices.keyboard

print("Begin Experiment", flush=True)
sys.stdout.flush()

HIDKeyboardBuffer = arr.array('u', ['.', '.', '.', '.', '.'])
oldHIDKeyboardBuffer = arr.array('u', ['.', '.', '.', '.', '.'])
chrFirstKeyDown = '.'
intKeyUpCount=0

#bbtk_psurp.openpsurpdatafile("C:\BBTK PSURP\PSURP_runner.txt", "D:\\PSYCHOPY\\PSURP FINAL\\" + u'data\\%s_%s_%s' % (expInfo['participant'], expName, expInfo['date']) + ".psl")
bbtk_psurp.openpsurpdatafile("C:\BBTK PSURP\PSURP_runner.txt", "C:\\BBTK PSURP\\PsychoPy v2021.2.2 Example\\" + u'data\\%s_%s_%s' % (expInfo['participant'], expName, expInfo['date']) + ".psl")
#bbtk_psurp.openpsurpdatafile("C:\BBTK PSURP\PSURP_runner.txt", "" + u'data\\%s_%s_%s' % (expInfo['participant'], expName, expInfo['date']) + ".psl")

# Initialize components for Routine "end"
endClock = core.Clock()
endText = visual.TextStim(win=win, name='endText',
    text="Thank you for your participation.\n\nYou have taken part in a priming experiment.\n\nWhere you were presented with RED simley face you will have typically pressed button 2 harder than when you were presented with GREEN smiley face and pressed button 1.\n\nTo see if this is true you will need to look at the recorded pressure curves.\n\nYou should also investigate RT's to see if there was a difference in response speeds between the two conditions.\n\nPress [SPACE] to quit.",
    font='Open Sans',
    pos=(0, 0), height=0.04, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
blackSquare2 = visual.Rect(
    win=win, name='blackSquare2',units='norm', 
    width=(0.4, 0.2)[0], height=(0.4, 0.2)[1],
    ori=0.0, pos=(0.9, 0),
    lineWidth=1.0,     colorSpace='rgb',  lineColor='black', fillColor='black',
    opacity=None, depth=-1.0, interpolate=True)

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "instructions"-------
continueRoutine = True
# update component parameters for each repeat
ready.keys = []
ready.rt = []
_ready_allKeys = []
# keep track of which components have finished
instructionsComponents = [instructText, ready, startSquare]
for thisComponent in instructionsComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
instructionsClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "instructions"-------
while continueRoutine:
    # get current time
    t = instructionsClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=instructionsClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *instructText* updates
    if instructText.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instructText.frameNStart = frameN  # exact frame index
        instructText.tStart = t  # local t and not account for scr refresh
        instructText.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instructText, 'tStartRefresh')  # time at next scr refresh
        instructText.setAutoDraw(True)
    
    # *ready* updates
    waitOnFlip = False
    if ready.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        ready.frameNStart = frameN  # exact frame index
        ready.tStart = t  # local t and not account for scr refresh
        ready.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ready, 'tStartRefresh')  # time at next scr refresh
        ready.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(ready.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(ready.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if ready.status == STARTED and not waitOnFlip:
        theseKeys = ready.getKeys(keyList=['space'], waitRelease=False)
        _ready_allKeys.extend(theseKeys)
        if len(_ready_allKeys):
            ready.keys = _ready_allKeys[-1].name  # just the last key pressed
            ready.rt = _ready_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # *startSquare* updates
    if startSquare.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        startSquare.frameNStart = frameN  # exact frame index
        startSquare.tStart = t  # local t and not account for scr refresh
        startSquare.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(startSquare, 'tStartRefresh')  # time at next scr refresh
        startSquare.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "instructions"-------
for thisComponent in instructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('instructText.started', instructText.tStartRefresh)
thisExp.addData('instructText.stopped', instructText.tStopRefresh)
# check responses
if ready.keys in ['', [], None]:  # No response was made
    ready.keys = None
thisExp.addData('ready.keys',ready.keys)
if ready.keys != None:  # we had a response
    thisExp.addData('ready.rt', ready.rt)
thisExp.addData('ready.started', ready.tStartRefresh)
thisExp.addData('ready.stopped', ready.tStopRefresh)
thisExp.nextEntry()
thisExp.addData('startSquare.started', startSquare.tStartRefresh)
thisExp.addData('startSquare.stopped', startSquare.tStopRefresh)
# the Routine "instructions" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('conditions.xlsx'),
    seed=None, name='trials')
thisExp.addLoop(trials)  # add the loop to the experiment
thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
if thisTrial != None:
    for paramName in thisTrial:
        exec('{} = thisTrial[paramName]'.format(paramName))

for thisTrial in trials:
    currentLoop = trials
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "black_marker"-------
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat
    # keep track of which components have finished
    black_markerComponents = [blackSquare]
    for thisComponent in black_markerComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    black_markerClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "black_marker"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = black_markerClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=black_markerClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *blackSquare* updates
        if blackSquare.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            blackSquare.frameNStart = frameN  # exact frame index
            blackSquare.tStart = t  # local t and not account for scr refresh
            blackSquare.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(blackSquare, 'tStartRefresh')  # time at next scr refresh
            blackSquare.setAutoDraw(True)
        if blackSquare.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > blackSquare.tStartRefresh + 2.0-frameTolerance:
                # keep track of stop time/frame for later
                blackSquare.tStop = t  # not accounting for scr refresh
                blackSquare.frameNStop = frameN  # exact frame index
                win.timeOnFlip(blackSquare, 'tStopRefresh')  # time at next scr refresh
                blackSquare.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in black_markerComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "black_marker"-------
    for thisComponent in black_markerComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials.addData('blackSquare.started', blackSquare.tStartRefresh)
    trials.addData('blackSquare.stopped', blackSquare.tStopRefresh)
    
    # ------Prepare to start Routine "white_marker"-------
    continueRoutine = True
    # update component parameters for each repeat
    image.setImage(imageFile)
    print("Begin Routine", flush=True)
    sys.stdout.flush()
    io.clearEvents('all')
    intKeyUpCount=0
    chrFirstKeyDown = '.'
    HIDKeyboardBuffer[0]='.'
    HIDKeyboardBuffer[1]='.'
    HIDKeyboardBuffer[2]='.'
    HIDKeyboardBuffer[3]='.'
    HIDKeyboardBuffer[4]='.'
    oldHIDKeyboardBuffer[0]='.'
    oldHIDKeyboardBuffer[1]='.'
    oldHIDKeyboardBuffer[2]='.'
    oldHIDKeyboardBuffer[3]='.'
    oldHIDKeyboardBuffer[4]='.'
    # keep track of which components have finished
    white_markerComponents = [whiteSquare, image]
    for thisComponent in white_markerComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    white_markerClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "white_marker"-------
    while continueRoutine:
        # get current time
        t = white_markerClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=white_markerClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *whiteSquare* updates
        if whiteSquare.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            whiteSquare.frameNStart = frameN  # exact frame index
            whiteSquare.tStart = t  # local t and not account for scr refresh
            whiteSquare.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(whiteSquare, 'tStartRefresh')  # time at next scr refresh
            whiteSquare.setAutoDraw(True)
        
        # *image* updates
        if image.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            image.frameNStart = frameN  # exact frame index
            image.tStart = t  # local t and not account for scr refresh
            image.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(image, 'tStartRefresh')  # time at next scr refresh
            image.setAutoDraw(True)
        win.flip()
        
        intKeyUpCount=0
        
        if frameN == 0:
            io.clearEvents('all')
            trial_start=core.getTime()
            datTrialOnsetDateTime = datetime.now().strftime('%Y/%m/%d %H:%M:%S.%f')[:-3]
        else:
            for e in keyboard.getKeys():
                if e.char == "a":
                    if HIDKeyboardBuffer[0]=='.':
                        HIDKeyboardBuffer[0]='a'
                        if chrFirstKeyDown == '.':
                            datFirstKeyDownDateTime = datetime.now().strftime('%Y/%m/%d %H:%M:%S.%f')[:-3]
                            chrFirstKeyDown = e.char
                            response_event=e 
                            print("chrFirstKeyDown = ", chrFirstKeyDown)
                    else:
                        HIDKeyboardBuffer[0]='.'
                if e.char == "b":
                    if HIDKeyboardBuffer[1]=='.':
                        HIDKeyboardBuffer[1]='b'
                        if chrFirstKeyDown == '.':
                            datFirstKeyDownDateTime = datetime.now().strftime('%Y/%m/%d %H:%M:%S.%f')[:-3]
                            chrFirstKeyDown = e.char
                            response_event=e
                            print("chrFirstKeyDown = ", chrFirstKeyDown)
                    else:
                        HIDKeyboardBuffer[1]='.'
                if e.char == "c":
                    if HIDKeyboardBuffer[2]=='.':
                        HIDKeyboardBuffer[2]='c'
                        if chrFirstKeyDown == '.':
                            datFirstKeyDownDateTime = datetime.now().strftime('%Y/%m/%d %H:%M:%S.%f')[:-3]
                            chrFirstKeyDown = e.char
                            response_event=e
                            print("chrFirstKeyDown = ", chrFirstKeyDown)
                    else:
                        HIDKeyboardBuffer[2]='.'
                if e.char == "e":
                    if HIDKeyboardBuffer[3]=='.':
                        HIDKeyboardBuffer[3]='e'
                        if chrFirstKeyDown == '.':
                            datFirstKeyDownDateTime = datetime.now().strftime('%Y/%m/%d %H:%M:%S.%f')[:-3]
                            chrFirstKeyDown = e.char
                            response_event=e
                            print("chrFirstKeyDown = ", chrFirstKeyDown)
                    else:
                        HIDKeyboardBuffer[3]='.'
                if e.char == "f":
                    if HIDKeyboardBuffer[4]=='.':
                        HIDKeyboardBuffer[4]='f'
                        if chrFirstKeyDown == '.':
                            datFirstKeyDownDateTime = datetime.now().strftime('%Y/%m/%d %H:%M:%S.%f')[:-3]
                            chrFirstKeyDown = e.char
                            response_event=e
                            print("chrFirstKeyDown = ", chrFirstKeyDown)
                    else:
                        HIDKeyboardBuffer[4]='.'
        
            if oldHIDKeyboardBuffer != HIDKeyboardBuffer:
                if HIDKeyboardBuffer[0]=='a':
                    print("A down", flush=True)
                else:
                    print("A up", flush=True)
                    intKeyUpCount+=1
                if HIDKeyboardBuffer[1]=='b':
                    print("B down", flush=True)
                else:
                    print("B up", flush=True)
                    intKeyUpCount+=1
                if HIDKeyboardBuffer[2]=='c':
                    print("C down", flush=True)
                else:
                    print("C up", flush=True)
                    intKeyUpCount+=1
                if HIDKeyboardBuffer[3]=='d':
                    print("D down", flush=True)
                else:
                    print("D up", flush=True)
                    intKeyUpCount+=1
                if HIDKeyboardBuffer[4]=='e':
                    print("E down", flush=True)
                else:
                    print("E up", flush=True)
                    intKeyUpCount+=1
        
                print(intKeyUpCount)
                if intKeyUpCount == 5:
                    datAllKeysUpDateTime = datetime.now().strftime('%Y/%m/%d %H:%M:%S.%f')[:-3]
                    print(intKeyUpCount)
                    intKeyUpCount=0
                    continueRoutine = False 
                    break
        
                oldHIDKeyboardBuffer = HIDKeyboardBuffer[:5] + oldHIDKeyboardBuffer[5:]
        
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in white_markerComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "white_marker"-------
    for thisComponent in white_markerComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials.addData('whiteSquare.started', whiteSquare.tStartRefresh)
    trials.addData('whiteSquare.stopped', whiteSquare.tStopRefresh)
    trials.addData('image.started', image.tStartRefresh)
    trials.addData('image.stopped', image.tStopRefresh)
    print("End Routine", flush=True)
    sys.stdout.flush()
    
    trials.addData("RTC Date Time", datTrialOnsetDateTime)
    trials.addData("resp.time", response_event.time)
    trials.addData("resp.rt", response_event.time-trial_start)
    trials.addData('resp.keys',response_event.key)
    trials.addData('resp.corr', response_event.key.lower()==corrAns)
    trials.addData("First Key Down", datFirstKeyDownDateTime)
    trials.addData("All Keys Up", datAllKeysUpDateTime)
    # the Routine "white_marker" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'trials'

# get names of stimulus parameters
if trials.trialList in ([], [None], None):
    params = []
else:
    params = trials.trialList[0].keys()
# save data for this loop
trials.saveAsExcel(filename + '.xlsx', sheetName='trials',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ------Prepare to start Routine "end"-------
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
endComponents = [endText, blackSquare2]
for thisComponent in endComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
endClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "end"-------
while continueRoutine:
    # get current time
    t = endClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=endClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *endText* updates
    if endText.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        endText.frameNStart = frameN  # exact frame index
        endText.tStart = t  # local t and not account for scr refresh
        endText.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(endText, 'tStartRefresh')  # time at next scr refresh
        endText.setAutoDraw(True)
    
    # *blackSquare2* updates
    if blackSquare2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        blackSquare2.frameNStart = frameN  # exact frame index
        blackSquare2.tStart = t  # local t and not account for scr refresh
        blackSquare2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(blackSquare2, 'tStartRefresh')  # time at next scr refresh
        blackSquare2.setAutoDraw(True)
    if blackSquare2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > blackSquare2.tStartRefresh + 2.0-frameTolerance:
            # keep track of stop time/frame for later
            blackSquare2.tStop = t  # not accounting for scr refresh
            blackSquare2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(blackSquare2, 'tStopRefresh')  # time at next scr refresh
            blackSquare2.setAutoDraw(False)
    win.flip()
    
    for e in keyboard.getKeys():
        #print(e.char)
        if e.char == " ":
            #bbtk_psurp.closepsurpdatafile("C:\BBTK PSURP\PSURP_runner.txt", "D:\\PSYCHOPY\\PSURP FINAL\\" + u'data\\%s_%s_%s' % (expInfo['participant'], expName, expInfo['date']) + ".psl")
            bbtk_psurp.closepsurpdatafile("C:\BBTK PSURP\PSURP_runner.txt", "" + u'data\\%s_%s_%s' % (expInfo['participant'], expName, expInfo['date']) + ".psl")
            core.quit()
            break
            
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in endComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "end"-------
for thisComponent in endComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('endText.started', endText.tStartRefresh)
thisExp.addData('endText.stopped', endText.tStopRefresh)
thisExp.addData('blackSquare2.started', blackSquare2.tStartRefresh)
thisExp.addData('blackSquare2.stopped', blackSquare2.tStopRefresh)
# the Routine "end" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()
# Stop the ioHub Server
io.quit()


# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
